diff -urN versao_6D/stoqdrivers-0.9.11/stoqdrivers/printers/fiscnet/FiscNetECF.py trunk/stoqdrivers/printers/fiscnet/FiscNetECF.py
--- versao_6D/stoqdrivers-0.9.11/stoqdrivers/printers/fiscnet/FiscNetECF.py	2016-12-29 14:30:59.000000000 -0200
+++ trunk/stoqdrivers/printers/fiscnet/FiscNetECF.py	2017-01-23 16:54:44.641415359 -0200
@@ -717,29 +1176,81 @@
             cro=self.get_cro(),
             crz=self.get_crz(),
             coo=self.get_coo(),
+            ccf=self.get_ccf(),
+            gnf=self.get_gnf(),
+            grg=self.get_grg(),
+            cdc=self.get_cdc(),
             period_total=self._read_register('TotalDiaVendaBruta', Decimal),
             total=self._read_register('GT', Decimal),
             taxes=self._get_taxes())
-
         return data
 
     def get_payment_receipt_identifier(self, method_name):
         # We don't need an identifier. Just return None
         return None
 
-    def payment_receipt_open(self, identifier, coo, method_id, value):
-        self._send_command('AbreCreditoDebito', CodMeioPagamento=int(method_id),
+    def payment_receipt_open(self, identifier, coo, method, value):
+        self._send_command('AbreCreditoDebito', CodMeioPagamento=int(method),
                            COO=coo, Valor=value)
 
     def payment_receipt_print(self, text):
-        self._send_command('ImprimeTexto', TextoLivre=text)
+        text = text.encode('cp850')
+        max_line = 7
+        inc = 1
+        imprime_linha = ''
+        for line in text.split('\n'):
+            if inc <= max_line:
+                line = line.replace('\\', '\\\\') # Vespague sucks
+
+            if len(imprime_linha + '\n' + line) > 492: # limite de caracteres do comando ImprimeTexto
+                self._send_command('ImprimeTexto', TextoLivre=imprime_linha)
+                imprime_linha = ''
+
+            inc += 1
+            if line == 'corta_papel':
+                if imprime_linha:
+                    self._send_command('ImprimeTexto', TextoLivre=imprime_linha)
+                    imprime_linha = ''
+
+                if not self.get_corta_papel():
+                    imprime_linha = '\n------------------------------------------------\n\n'
+
+                continue
+
+            imprime_linha += '\n' + line
+
+        self._send_command('ImprimeTexto', TextoLivre=imprime_linha) # imprime a o restante do texto
 
     def payment_receipt_close(self):
         self._send_command('EncerraDocumento')
+        self.get_corta_papel()
 
     def payment_receipt_print_duplicate(self):
         self._send_command('EmiteViaCreditoDebito')
 
+    def gerencial_report_open(self, id=0):
+        self._send_command('AbreGerencial', CodGerencial=id)
+
+    def gerencial_report_print(self, text):
+        text = text.encode('cp850')
+        imprime_linha = ''
+        for line in text.split('\n'):
+            line = line.replace('\\', '\\\\') # Vespague sucks
+            if len(imprime_linha + '\n' + line) > 492: # limite de caracteres do comando ImprimeTexto
+                self._send_command('ImprimeTexto', TextoLivre=imprime_linha)
+                imprime_linha = ''
+
+            imprime_linha += '\n' + line
+
+        self._send_command('ImprimeTexto', TextoLivre=imprime_linha)
+
+    def gerencial_report_close(self):
+        self._send_command('EncerraDocumento')
+        self.get_corta_papel()
+
+    # FIX ME
+    def get_grande_total(self):
+        return self._read_register('GT', Decimal)
 
 class FiscNetChequePrinter(FiscNetECF, BaseChequePrinter):
     implements(IChequePrinter)
@@ -782,6 +1293,25 @@
                     cheque_value=Capability(digits=14, decimals=4),
                     cheque_city=Capability(max_len=27))
 
+    def get_last_reduce(self):
+        dec = Decimal('0')
+        retval = {'CRO': dec,
+                  'CRZ': dec,
+                  'COO': dec,
+                  'GNF': dec,
+                  'CCF': dec,
+                  'GRG': dec,
+                  'CFD': dec,
+                  'NFC': dec,
+                  'CFC': dec,
+                  'COM': dec,
+                  'CER': dec,
+                  'CDC': dec,
+                  'NCN': dec,
+                  'CCDC': dec,
+                  'GT': dec,
+                  'VBD': dec}
+        return retval
     def get_capabilities(self):
         caps = super(FiscNetChequePrinter, self).get_capabilities()
         caps.update(self._get_cheque_capabilities())
